// Quick'n dirty test for uODDskInfo unit
// (c) 1-2000 Olivier Dahan odahan@cybercable.fr
unit utest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    od1: TOpenDialog;
    Edit1: TEdit;
    Label2: TLabel;
    Memo1: TMemo;
    SpeedButton1: TSpeedButton;
    Shape1: TShape;
    Shape2: TShape;
    Label3: TLabel;
    lb1: TListBox;
    Label4: TLabel;
    Button1: TButton;
    Label5: TLabel;
    Image1: TImage;
    Image2: TImage;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    lb2: TListBox;
    Label19: TLabel;
    Button2: TButton;
    Button3: TButton;
    Label20: TLabel;
    Bevel1: TBevel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Shape3: TShape;
    Edit2: TEdit;
    SpeedButton2: TSpeedButton;
    Label29: TLabel;
    od2: TOpenDialog;
    Image3: TImage;
    Image4: TImage;
    Button4: TButton;
    Shape4: TShape;
    Shape5: TShape;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Dclarations prives }
    procedure ReadInfos;
    procedure LoadFileInfo;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

uses uODDskInfo;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;
begin
 ListView1.LargeImages :=  vODLargeImages;
 ListView1.SmallImages := vODLittleImages;
 for i:=0 to vODLargeImages.Count-1 do
  with ListView1.Items.Add do
   begin
    Caption := 'Img ' + Inttostr(i);
    ImageIndex := i;
   end;
 edit1.text := Application.Exename;
 ReadInfos;
 GetLogicalDriveList(lb1.items);
 edit2.text := Application.Exename;
 LoadFileInfo;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 if RadioGroup1.ItemIndex=0 then
  listView1.ViewStyle := vsIcon
   else
  listView1.ViewStyle := vsSmallIcon;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
 if od1.Execute then
  begin
   edit1.text := od1.filename;
   Readinfos;
  end;
end;

procedure TForm1.ReadInfos;
begin
 with TODVersionReader.CreateWithFile(edit1.text) do
  try
   Memo1.lines.text := '';
   if not versionExists then
    memo1.lines.add('No version info for this file !')
    else memo1.lines.add(AllVersionInfo);
  finally
   free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var info : toddriveshellinfo; b:tbitmap;
    volinfo : todvolumeinformation;
    freecaller,total,totalfree: int64;
begin
 if lb1.itemindex>-1 then
 begin
  label5.caption := GetDriveTypeStr(lb1.items[lb1.itemindex][1]);
  GetDriveShellInfo(lb1.items[lb1.itemindex][1],info);
  b:=tbitmap.create;
  try
   vODLargeImages.GetBitmap(info.Image,b);
   Image1.Picture.assign(b);
   vODLittleImages.GetBitmap(info.Image,b);
   Image2.Picture.assign(b);
  finally
   b.free;
  end;
  label6.caption := info.DisplayName;
  label7.caption := info.TypeName;
  GetVolumeInformation(lb1.items[lb1.itemindex][1],volinfo);
  label12.caption := volinfo.VolumeName;
  label14.caption := volinfo.FileSystemName;
  Label16.caption := getSerialStr(volinfo.VolumeSerialNumber);
  label18.caption := inttostr(volinfo.MaximumComponentLength);
  GetSysFlagsStr(volinfo.FileSystemFlags,lb2.items);
  GetDiskSpace(lb1.items[lb1.itemindex][1],freecaller,total,totalfree);
  Label22.caption := FormatFloat('##,##0.#',total / 1024.0 / 1024.0);
  Label24.caption := FormatFloat('##,##0.#',totalfree / 1024.0 / 1024.0);
  Label26.caption := FormatFloat('##,##0.#',freecaller / 1024.0 / 1024.0);
  label28.caption := GetNetworkVolumeName(lb1.items[lb1.itemindex][1]);
 end
 else begin
      label5.caption := 'Select a drive !';
      end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if lb1.itemindex>-1 then
  begin
   Showmessage('Last disk error is :'#13#10+
     DiskErrorMessage(lb1.items[lb1.itemindex][1]));
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if lb1.itemindex>-1 then
    if DiskRetry(lb1.items[lb1.itemindex][1])
     then showmessage('User wants to retry')
     else showmessage('User wants to abort');
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
 if od2.execute then
  begin
   edit2.text := od2.filename;
   loadFileInfo;
  end;
end;

procedure TForm1.LoadFileInfo;
var ic:ticon;
    name,typ:string;
    attr,img:integer;
    b:tbitmap;
    info:todfileinformation;
begin
 GetShellInfo(edit2.text,name,typ,ic,attr,img);
 b:=tbitmap.create;
  try
   vODLargeImages.GetBitmap(img,b);
   Image3.Picture.assign(b);
   vODLittleImages.GetBitmap(Img,b);
   Image4.Picture.assign(b);
  finally
   b.free;
  end;
 label31.caption := name;
 label33.caption := typ;
 label35.caption := ExtractShortPathName(edit2.text);
 GetODFileInfo(edit2.text,info);
 label37.caption := FormatFloat('##,##0.0#',info.exSize / 1024.0 / 1024.0);
 if info.exsize<1024*1024 then label37.caption:=label37.caption+' ('+FormatFloat('#,###,##0 b',info.exSize)+')';
 label39.caption := info.AltName;
 label41.caption := FileAttrStr(info.Attr);
 label43.Caption := datetimetostr(info.Creation);
 label45.Caption := datetimetostr(info.Lastwrite);
 label47.Caption := datetimetostr(info.LastAccess);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 LoadFileInfo;
end;

end.
